﻿// © 2009 Michele Leroux Bustamante. All rights reserved. 
// See http://claimsbasedwpf.codeplex.com for related whitepaper and updates
// For an intro to WCF see Michele's book: Learning WCF, O'Reilly 2007 (updated August 2008 for VS 2008)
// See http://www.thatindigogirl.com for the book code!
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.IdentityModel.Tokens;
using System.IdentityModel.Tokens;
using Microsoft.IdentityModel.Claims;
using System.Security;

namespace RPSTS
{
    public class CustomUserNameSecurityTokenHandler : UserNameSecurityTokenHandler
    {
        public CustomUserNameSecurityTokenHandler()
        {
        }

      
        public override bool CanValidateToken
        {
            get
            {
                return true;
            }
        }

        public override Microsoft.IdentityModel.Claims.ClaimsIdentityCollection ValidateToken(System.IdentityModel.Tokens.SecurityToken token)
        {
            
            UserNameSecurityToken userNameToken = token as UserNameSecurityToken;
            if (userNameToken == null)
                throw new SecurityException(string.Format("Invalid token provided: {0}. Expecting UserNameSecurityToken.", token.GetType()));

            // TODO: authenticate the caller against the credential store
            // this sample uses an in-memory credential store
            // see CredentialStore.cs

            CredentialStore.AuthenticateUser(userNameToken.UserName, userNameToken.Password);
            // will throw if fails

            ClaimsIdentityCollection identities = new ClaimsIdentityCollection();
            ClaimsIdentity claimsIdentity = new ClaimsIdentity("CustomUserNameSecurityTokenHandler");

            claimsIdentity.Claims.Add(new Claim(System.IdentityModel.Claims.ClaimTypes.Name, userNameToken.UserName));
            identities.Add(claimsIdentity);

            return identities;
        }
    }

}
