﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.IdentityModel.Claims;

namespace TodoListHost
{
    public class CustomClaimsAuthorizationManager : ClaimsAuthorizationManager
    {
        public CustomClaimsAuthorizationManager()
        {
        }

        public override bool CheckAccess(AuthorizationContext context)
        {

            if (context.Resource.Where(x => x.ClaimType ==
                System.IdentityModel.Claims.ClaimTypes.Name && x.Value ==
                "http://localhost:8000/TodoListService").Count() > 0)
            {
                if (context.Action.Where(x => x.ClaimType ==
                    System.IdentityModel.Claims.ClaimTypes.Name && x.Value ==
                    Constants.Actions.GetItems).Count() > 0)
                {
                    return context.Principal.IsInRole(
                           Constants.Permissions.Read);
                }
                else if (context.Action.Where(x => x.ClaimType ==
                    System.IdentityModel.Claims.ClaimTypes.Name && x.Value ==
                    Constants.Actions.CreateItem).Count() > 0)
                {
                    return context.Principal.IsInRole(
                           Constants.Permissions.Create);
                }
                else if (context.Action.Where(x => x.ClaimType ==
                    System.IdentityModel.Claims.ClaimTypes.Name && x.Value ==
                    Constants.Actions.DeleteItem).Count() > 0)
                {
                    return context.Principal.IsInRole(
                           Constants.Permissions.Delete);
                }
                else if (context.Action.Where(x => x.ClaimType ==
                    System.IdentityModel.Claims.ClaimTypes.Name && x.Value ==
                    Constants.Actions.UpdateItem).Count() > 0)
                {
                    return context.Principal.IsInRole(
                           Constants.Permissions.Update);
                }

            }
            return false;
        }
    }
}
